var items_js = $('<script type="text/javascript" src="./dist/js/needlework_items.js"></script>');
var policy_js = $('<script type="text/javascript" src="./dist/js/needlework_policy.js"></script>');
var oneline_js = $('<script type="text/javascript" src="./dist/js/needlework_oneline.js"></script>');
var scenario_js = $('<script type="text/javascript" src="./dist/js/needlework_scenario.js"></script>');
var setting_js = $('<script type="text/javascript" src="./dist/js/needlework_setting.js"></script>');
var update_js = $('<script type="text/javascript" src="./dist/js/needlework_update.js"></script>');

$(items_js).appendTo("head");
$(policy_js).appendTo("head");
$(oneline_js).appendTo("head");
$(scenario_js).appendTo("head");
$(setting_js).appendTo("head");
$(update_js).appendTo("head");
//var test = $('<script type="text/javascript" src="./dist/js/test/test.js"></script>');
//$(test).appendTo("head");

/**
 * グローバル変数
 */
var oneline = new OneLine();
var scenario = new Scenario();
var needle = null;
var ERROR_MESSAGES = null;

/**
 * グローバル関数群
 */
$(document).ready(function () {
    // 起動時にNeedleworkのIPを取得する
    get_server_addr();
    // Keepalive開始
    keepalive();  // setInterval実行から5秒後に初回keepaliveとなるため、コンソール起動直後に一度手動で実行する
    setInterval("keepalive()", 5000);
    //外部定義されたエラーメッセージを取得する。
    Read_ErrorMessage();
});
// サーバの到達性確認
function keepalive() {
    $.ajax({
        type: 'GET',
        url: 'http://192.0.2.1:8080/version',
        dataType: 'json',
        timeout: 3000,
    }).then(
        function (data) {
            // 接続成功
            $('#status-unreachable').css('display', 'none');
            $('#status-connected').css('display', 'block');
            get_server_addr();
        },
        function (data) {
            // 接続失敗
            $('#status-connected').css('display', 'none');
            $('#status-unreachable').css('display', 'block');
            needle = null;
        }
        )
}

// NeedleworkのIPを取得する
// ※Needleworkと仮想ホストのNW重複を確認するため
function get_server_addr() {
    $.ajax({
        type: 'GET',
        url: 'http://192.0.2.1:8080/1/setting',
        dataType: 'json',
        timeout: 3000,
    }).done(function (data) {
        needle = {};//nullにはプロパティを追加できないため、再度初期化
        var devices = data.Devices;
        needle.eth0 = devices.Eth0.IPAddr.split('/')[0];
        needle.eth1 = devices.Eth1.IPAddr.split('/')[0];
        needle.eth2 = devices.Eth2.IPAddr.split('/')[0];
        needle.mgt0 = devices.Mgt0.IPAddr.split('/')[0];
    })
}
// 時刻取得関数
function getNow() {
    var now = new Date();
    var year = now.getFullYear();
    var mon = now.getMonth() + 1;
    var day = now.getDate();
    var hour = now.getHours();
    var min = now.getMinutes();
    var sec = now.getSeconds();
    var s = year + '.' + mon + '.' + day + ' ' + hour + ":" + min + ":" + sec;
    return s;
}

function Read_ErrorMessage() {
    $.getJSON("./messages.json", function (data) {
        ERROR_MESSAGES = data;
    });
}
