
//
//
//        Setting
//
//

//Reloadボタンクリック時
$(".reload_setting").click(function () {
    get_settings();
})

function get_settings() {
    // 各フィールドを空欄にする
    $('#settings-eth0-addr').val("");
    $('#settings-eth1-addr').val("");
    $('#settings-eth2-addr').val("");
    $('#settings-mgt-addr').val("");
    $('#settings-dns').val("");
    $('#settings-gateway').val("");

    // 回転するアイコンを出す
    $('.settings-msg').html('<i class="fa fa-spinner fa-pulse"></i>')

    // disable reload button
    $('#content-settings button').attr('disabled', 'disabled')

    setTimeout(function () {
        $.ajax({
            type: 'GET',
            url: 'http://192.0.2.1:8080/1/setting',
            dataType: 'json',
            timeout: 3000,
        }).then(
            function (data) {
                setting_set_form(data);
            },
            function (xhr) {
                unable_connection_msg();
            }
            )
    }, 500);
}
function setting_set_form(data) {
    if (data.Devices.Eth0.IPAddr) {
        $('#settings-eth0-addr').val(data.Devices.Eth0.IPAddr);
    }
    if (data.Devices.Eth1.IPAddr) {
        $('#settings-eth1-addr').val(data.Devices.Eth1.IPAddr);
    }
    if (data.Devices.Eth2.IPAddr) {
        $('#settings-eth2-addr').val(data.Devices.Eth2.IPAddr);
    }
    if (data.Devices.Mgt0.IPAddr) {
        $('#settings-mgt-addr').val(data.Devices.Mgt0.IPAddr);
    }
    if (data.DNS) {
        $('#settings-dns').val(data.DNS[0]);
    }
    if (data.Routes.NextHop) {
        $('#settings-gateway').val(data.Routes.NextHop[0]);
    }
    $('.settings-msg').html('')
    if ($('#scenario-filename').val() === '') {//scenarioのcsvインポート中はApplyできない。
        $('#content-settings button').removeAttr('disabled', 'disabled');
    }
    $('#mgt-button').attr('disabled', 'disabled')
}


function unable_connection_msg() {
    var box_names = ["eth0", "eth1", "eth2", "mgt", "dns", "gateway"]
    for (var i in box_names) {
        $('#settings-' + box_names[i] + '-msg').html('<span style="color:red">Error: Unable to connect to server.</span>')
    }
    if ($('#scenario-filename').val() === '') {//scenarioのcsvインポート中はApplyできない。
        $('#content-settings button').removeAttr('disabled', 'disabled');
    }
    $('#mgt-button').attr('disabled', 'disabled')
}

function set_interface(device, ip) {
    $('#content-settings button').attr('disabled', 'disabled')
    $('#settings-' + device + '-msg').html('<i class="fa fa-spinner fa-pulse"></i>')
    $.ajax({
        type: 'PUT',
        url: 'http://192.0.2.1:8080/1/setting/device/' + device + '?ip=' + encodeURIComponent(ip),
        dataType: 'json',
        timeout: 30000,
    }).then(
        function (data) {
            $('#settings-' + device + '-msg').html('<i class="fa fa-check" style="color:#00a65a"></i>')
            $('#content-settings button').removeAttr('disabled', 'disabled')
            $('#mgt-button').attr('disabled', 'disabled')
        },
        function (xhr) {
            interface_error_msg(xhr, '#settings-' + device + '-msg', 204);
        }
        )
}

function set_route(ip) {
    $('#content-settings button').attr('disabled', 'disabled')
    $('#settings-gateway-msg').html('<i class="fa fa-spinner fa-pulse"></i>')
    setTimeout(function () {
        $.ajax({
            type: 'POST',
            url: 'http://192.0.2.1:8080/1/setting/route?dst=0.0.0.0' + encodeURIComponent('/') + '0&next=' + ip,
            dataType: 'json',
            timeout: 30000,
        }).then(
            function (data) {
                $('#settings-gateway-msg').html('<i class="fa fa-check" style="color:#00a65a"></i>')
                $('#content-settings button').removeAttr('disabled', 'disabled')
                $('#mgt-button').attr('disabled', 'disabled')
                //ipを再度取得
                get_server_addr();
            },
            function (xhr) {
                interface_error_msg(xhr, '#settings-gateway-msg', 201);
            }
            )
    }, 500);
}

function del_route() {
    $('#content-settings button').attr('disabled', 'disabled')
    $('#settings-gateway-msg').html('<i class="fa fa-spinner fa-pulse"></i>')
    setTimeout(function () {
        $.ajax({
            type: 'DELETE',
            url: 'http://192.0.2.1:8080/1/setting/route',
            dataType: 'json',
            timeout: 30000,
        }).then(
            function () {
                $('#settings-gateway-msg').html('<i class="fa fa-check" style="color:#00a65a"></i>')
                $('#content-settings button').removeAttr('disabled', 'disabled')
                $('#mgt-button').attr('disabled', 'disabled')
                $('#settings-gateway').val('')
            }
            )
    }, 500);
}

function set_dns(ip) {
    $('#content-settings button').attr('disabled', 'disabled')
    $('#settings-dns-msg').html('<i class="fa fa-spinner fa-pulse"></i>')
    setTimeout(function () {
        $.ajax({
            type: 'POST',
            url: 'http://192.0.2.1:8080/1/setting/dns?ip=' + ip,
            dataType: 'json',
            timeout: 30000,
        }).then(
            function (data) {
                $('#settings-dns-msg').html('<i class="fa fa-check" style="color:#00a65a"></i>')
                $('#content-settings button').removeAttr('disabled', 'disabled')
            },
            function (xhr) {
                interface_error_msg(xhr, '#settings-dns-msg', 201);
            }
            )
    }, 500);
}

function del_dns() {
    $('#content-settings button').attr('disabled', 'disabled')
    $('#settings-dns-msg').html('<i class="fa fa-spinner fa-pulse"></i>')
    setTimeout(function () {
        $.ajax({
            type: 'DELETE',
            url: 'http://192.0.2.1:8080/1/setting/dns',
            dataType: 'json',
            timeout: 30000,
        }).then(
            function (data) {
                $('#settings-dns-msg').html('<i class="fa fa-check" style="color:#00a65a"></i>')
                $('#content-settings button').removeAttr('disabled', 'disabled')
                $('#mgt-button').attr('disabled', 'disabled')
                $('#settings-dns').val('')
            }
            )
    }, 500);
}

//statusに応じて任意セレクタにエラー表示
function interface_error_msg(xhr, selector, status_num) {
    if (xhr.status === status_num) {
        $(selector).html('<i class="fa fa-check" style="color:#00a65a"></i>')
    } else if (xhr.responseJSON) {
        $(selector).html('<span style="color:red">Error: ' + xhr.responseJSON.Message + '</span>')
    } else {
        $(selector).html('<span style="color:red">Error: Unable to connect to server.</span>')
    }
    $('#content-settings button').removeAttr('disabled', 'disabled')
    $('#mgt-button').attr('disabled', 'disabled')
}

// Settingクリック時
$(".sidebar-settings").click(function() {
    $('.content-wrapper').css('display', 'none');
    $('#content-settings').css('display', 'block');
    $('.sidebar-menu li').removeClass('active')
    $('.sidebar-menu #menu-settings').addClass('active')
    get_settings();
});