//
//Scenario
//
Scenario = function () {
    this.test = new Test();
    //Scenarioのメソッド
    Scenario.prototype.CheckResult = function (result) {
        var policies = $(".scenario-table-row");
        var pass = [];
        var drop = [];
        var error_mismatch = [];
        var rows = [];
        JudgeCount();//各種配列の準備
        switch (result) {
            case "all":
                return Check(null, rows, "#scenario-all-left");
            case "pass":
                return Check(pass, rows, "#scenario-pass-left");
            case "drop":
                return Check(drop, rows, "#scenario-drop-left");
            case "error_mismatch":
                return Check(error_mismatch, rows, "#scenario-error");
        }
    
        /*
        struct Row{
            this.num;
            this.expect;
            this.results;//array
            this.display;//bool
        }*/
        //各判定をカウント
        function JudgeCount() {//行のオブジェクト作成と、各resultごとの数を集計
            for (var i in policies) {
                var policy = policies[i];
                if (i == "length") { return 0; }//プロパティがlengthまで進めばokとする
                var row = {}
                row.num = policy.children[0].innerText;
                row.expect = policy.children[7].innerText;
                if (policy.children[8].length === 2) {//resultが2つ存在する。
                    row.results = [policy.children[8].children[0].innerText, policy.children[8].children[1].innerText];
                    Counter(policy.children[8].children[0].innerText);
                    Counter(policy.children[8].children[1].innerText);
                } else {
                    row.results = [policy.children[8].children[0].innerText];
                    Counter(policy.children[8].children[0].innerText);
                }
                row.display = this.test.isDisplayElement($(policy));
                rows.push(row);
            }
            function Counter(result) {//resultによって配列へ追加する。
                switch (result) {
                    case "pass":
                        pass.push(row.num);
                        break;
                    case "drop":
                        drop.push(row.num);
                        break;
                    case "error":
                        error_mismatch.push(row.num);
                        break;
                    case "error_mismatch":
                        error_mismatch.push(row.num);
                        break;
                }
            }
        }
        //resultごとの配列に入っているrowのvisibleがfalseでなければ正しい
        function Check(array, rows, count_selector) {
            var count = 0;
            if (rows.length < 1) { return -1; }
            if (array === null) {
                for (var i = 0; i < rows.length; i++) {
                    if (rows[i].display === "false") { return -1; }
                    else { count++; }
                }
                if (count !== rows.length) { return -2 }
                return 0;
            }
            else {//allの時
                for (var i = 0; i < array.length; i++) {
                    var num = array[i];
                    if (rows[num - 1].display === "false") { return -1; }
                    else { count++; }
                }
                if (count !== parseInt($(count_selector).text())) { return -2; }
                return 0;//すべてtrueならば正しい
            }
        }
    }
    //Scenarioテスト用メソッド
    Scenario.prototype.CheckPass = function () {//passを押した時に、表示されるplocyがresultがpassのものだけ
        $("scenario-pass-box").click();
        var result = this.CheckResult("pass");
        if (result === 0) { TestResult("OK","check Pass"); }
        else if (result === -2) { TestResult("NG","(no much sum)"); }
        else { TestResult("NG"); }
    }
    Scenario.prototype.CheckDrop = function () {
        $("scenario-drop-box").click();
        var result = this.CheckResult("drop");
        if (result === 0) { TestResult("OK","check Drop"); }
        else { TestResult("NG"); }
    }
    Scenario.prototype.CheckAllPolicies = function () {
        $("scenario-all-box").click();
        var result = this.CheckResult("all");
        if (result === 0) { TestResult("OK","check All Policies"); }
        else { TestResult("NG"); }
    }
    Scenario.prototype.CheckErrorMismatchPolicies = function () {
        $("scenario-all-box").click();
        var result = this.CheckResult("error_mismatch");
        if (result === 0) { TestResult("OK","check error/mismatch"); }
        else { TestResult("NG"); }
    }
    Scenario.prototype.CheckClearButton = function () {
        $("#scenario-clear-table").click();
        Sleep(1000, '$("#modal-scenario-clear-table-close").click()');
        Sleep(2000, '$("#scenario-clear-table").click()');
        Sleep(3000, '$("#modal-scenario-clear-table-continue").click()');
        TestResult("OK","check clear button");
    }
    Scenario.prototype.CheckPlayPolicy = function () {
        $("#scenario-test-start").click();
        Sleep(1000, '$("#scenario-test-pause").click()');
        this.test.SleepClick(1000, '#scenario-test-pause');
        this.test.SleepClick(3000, '#scenario-test-start');
    }
    Scenario.prototype.CheckRetryPolicy = function () {
        $(".scenario-retry-btn")[0].click();
        Sleep(1000, '$(".scenario-retry-btn")[5].click()');
    }
}

$("#scenario-checkpass").click(function() {
    scenario.CheckPass();
})
$("#scenario-checkdrop").click(function() {
    scenario.CheckDrop();
})
$("#scenario-checkall").click(function() {
    scenario.CheckAllPolicies();
})
$("#scenario-checkerrormismatch").click(function() {
    scenario.CheckErrorMismatchPolicies();
})
$("#scenario-checkclearbutton").click(function() {
    scenario.CheckClearButton();
})
$("#scenario-checkplaypolicy").click(function() {
    scenario.CheckPlayPolicy();
})
$("#scenario-checkretrypolicy").click(function() {
    scenario.CheckRetryPolicy();
})